//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//+------------------------------------------------------------------
#property indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color1  LimeGreen
#property  indicator_color2  LimeGreen
#property  indicator_color3  Orange
#property  indicator_color4  Orange
#property  indicator_color5  DimGray
#property  indicator_width1  2
#property  indicator_width3  2
#property  indicator_width5  2

//
//
//
//
//

extern double Period1         =  32;
extern double Period2         =   5;
extern double Period3         =   5;
extern int    Price           = PRICE_CLOSE;
extern int    BarsPerSymbol   = 100;
extern double alertsLevelUp   =  20;
extern double alertsLevelDown = -20;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern string TimeFrame       = "Current time frame";
extern string Symbols         = "EURUSD;GBPUSD;USDCHF";
extern string UniqueID        = "Multi pair Blau TSI";
extern string _               = "separator colors";
extern color  textColor       = Black;
extern color  crossColor      = Gold;
extern color  backColor       = DarkGray;
extern color  boxColor        = Black;
extern int    separatorWidth  = 6;

//
//
//
//
//

double histouu[];
double histoud[];
double histodd[];
double histodu[];
double value[];
double work[];
double slope[];
double cross[];

//
//
//
//
//

int      window;  
string   aPairs[];
string   shortName;
double   minValue;
double   maxValue;
double   maxValues[];
int      timeFrame;
bool     calculateValue;
string   indicatorFileName;


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,histouu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,histoud); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,histodd); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,histodu); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,value);
   SetIndexBuffer(5,work);
   SetIndexBuffer(6,slope);
   SetIndexBuffer(7,cross);
      calculateValue    = (TimeFrame == "calculateValue"); if (calculateValue) return(0);
      indicatorFileName = WindowExpertName();

      //
      //
      //
      //
      //

      Symbols = StringTrimLeft(StringTrimRight(Symbols));
      if (StringSubstr(Symbols,StringLen(Symbols),1) != ";")
                       Symbols = StringConcatenate(Symbols,";");

         //
         //
         //
         //
         //                                   
            
         int s =  0;
         int i =  StringFind(Symbols,";",s);
         while (i > 0)
         {
            string current = StringSubstr(Symbols,s,i-s);
            ArrayResize(aPairs,ArraySize(aPairs)+1);
                        aPairs[ArraySize(aPairs)-1] = current;
                        if (current == Symbol())
                        {
                           string temp      = aPairs[0];
                                  aPairs[0] = current;
                                  aPairs[ArraySize(aPairs)-1] = temp;
                        }                                       
            s = i + 1;
            i = StringFind(Symbols,";",s);
         }
         ArrayResize(maxValues,ArraySize(aPairs));

      //
      //
      //
      //
      //
 
      separatorWidth = MathMax(separatorWidth,4);
      shortName      = UniqueID;
      timeFrame      = stringToTimeFrame(TimeFrame);
      SetLevelValue(0,alertsLevelUp);
      SetLevelValue(1,alertsLevelDown);
   IndicatorShortName(shortName);
   return(0);
}

//
//
//
//
//

int deinit()
{
   for (int i = 0; i < ArraySize(aPairs); i++)
   { 
         ObjectDelete(shortName+i);
         ObjectDelete(shortName+i+i);
         ObjectDelete(shortName+i+i+i);
   }         
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   if (calculateValue) { calculateIndicator(); return(0); }
   int    i,k,limit = ArraySize(aPairs);
   double max;
   
   //
   //
   //
   //
   //

   window = WindowFind(shortName);  
   ArrayInitialize(maxValues,0);
         minValue = 0;
         maxValue = 0;
                for(i=0,k=0; i<limit; i++) calculateValues(aPairs[i],BarsPerSymbol,k,i);
                for(i=0;     i<limit; i++) if (max < maxValues[i]) max = maxValues[i];
                for(i=0,k=0; i<limit; i++) plotGraph(aPairs[i],BarsPerSymbol,k,i,max);
   for (i=0;i<indicator_buffers;i++) SetIndexDrawBegin(i,Bars-k);
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void plotGraph(string symbol,int limit, int& shift,int element, double max)
{
   for(int i=limit; i>=0; i--)
   {   
      value[i+shift]   = work[i+shift];
      histouu[i+shift] = EMPTY_VALUE;
      histoud[i+shift] = EMPTY_VALUE;
      histodd[i+shift] = EMPTY_VALUE;
      histodu[i+shift] = EMPTY_VALUE;
      if (work[i+shift]>0)
         if (slope[i+shift]==1)
               histouu[i+shift] = work[i+shift];
         else  histoud[i+shift] = work[i+shift];
      if (work[i+shift]<0)
         if (slope[i+shift]==-1)
               histodd[i+shift] = work[i+shift];
         else  histodu[i+shift] = work[i+shift];
   }
   createLabel(symbol,element,shift+limit+separatorWidth-2,isSignalCrossing(shift));
   
   //
   //
   //
   //
   //
   
   shift += (limit+separatorWidth-1);
}

//
//
//
//
//

bool isSignalCrossing(int shift)
{
   double res = (work[shift]*work[shift+1]); 
   return(res<=0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

void calculateIndicator()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return;
      if(counted_bars>0) counted_bars--;
           int limit=MathMax(Bars-counted_bars,Bars-1);
           
   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      double priceDiff = iMA(NULL,0,1,0,MODE_SMA,Price,i)-iMA(NULL,0,1,0,MODE_SMA,Price,i+1);
      double avg = iEma(iEma(iEma(        priceDiff ,Period1,i,0),Period2,i,1),Period3,i,2);
      double ava = iEma(iEma(iEma(MathAbs(priceDiff),Period1,i,3),Period2,i,4),Period3,i,5);
         if (ava != 0)
               value[i] = 100.0*avg/ava;
         else  value[i] = 0;                  
               slope[i] = slope[i+1];
               cross[i] = 0;
                  if (value[i] > value[i+1]) slope[i] =  1;
                  if (value[i] < value[i+1]) slope[i] = -1;
                  if (value[i] > alertsLevelUp)   cross[i] =  1;
                  if (value[i] < alertsLevelDown) cross[i] = -1;
   }
   if (alertsOn)
   {
      int forBar = 1; if (alertsOnCurrent) forBar=0;
      if (cross[forBar]!=cross[forBar+1])
      {
         if(cross[forBar]== 1) doAlert(forBar,"crossed "+DoubleToStr(alertsLevelUp  ,2)+" up");
         if(cross[forBar]==-1) doAlert(forBar,"crossed "+DoubleToStr(alertsLevelDown,2)+" down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Blau TSI ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Blau TSI "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//

double workEma[][6];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
} 

//
//
//
//
//

void calculateValues(string symbol,int limit,int& shift,int element)
{
   for(int i=0; i<limit; i++)
   {
      int y=iBarShift(NULL,timeFrame,Time[i]);
         work[i+shift]  = iCustom(symbol,timeFrame,indicatorFileName,Period1,Period2,Period3,Price,0,alertsLevelUp,alertsLevelDown,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,"calculateValue",4,y);
         slope[i+shift] = iCustom(symbol,timeFrame,indicatorFileName,Period1,Period2,Period3,Price,0,alertsLevelUp,alertsLevelDown,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,"calculateValue",6,y);
          
      maxValues[element] = MathMax(MathAbs(work[i+shift]),maxValues[element]);
      maxValue           = MathMax(work[i+shift],maxValue);
      minValue           = MathMin(work[i+shift],minValue);
   }            

   //
   //
   //
   //
   //

   for (i=0;i<separatorWidth;i++) {
         histouu[shift+limit+i] = EMPTY_VALUE;
         histoud[shift+limit+i] = EMPTY_VALUE;
         histodd[shift+limit+i] = EMPTY_VALUE;
         histodu[shift+limit+i] = EMPTY_VALUE;
         value[shift+limit+i]   = EMPTY_VALUE;
         work[shift+limit+i]    = EMPTY_VALUE;
      }         
   shift += (limit+separatorWidth-1);
   return;
}



//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//


void createLabel(string symbol,int element, int shift, bool signalCrossing)
{
   string name = shortName+element;
   double price1 = maxValue;
   double price2 = minValue;
   
   //
   //
   //
   //
   //
   
   if (ObjectFind(name) == -1)
         ObjectCreate(name,OBJ_TEXT,window,0,0);
            ObjectSet(name,OBJPROP_ANGLE,90);
            ObjectSet(name,OBJPROP_TIME1 ,Time[shift]);
            ObjectSet(name,OBJPROP_PRICE1,(price1+price2)/2);
            if (signalCrossing)
                 ObjectSet(name,OBJPROP_COLOR,crossColor);
            else ObjectSet(name,OBJPROP_COLOR,textColor);
            ObjectSetText(name,symbol,10,"Arial bold");

   //
   //
   //
   //
   //

   name = shortName+element+element;
   if (ObjectFind(name) == -1)
         ObjectCreate(name,OBJ_RECTANGLE,window,0,0,0,0);
            ObjectSet(name,OBJPROP_COLOR,backColor);
            ObjectSet(name,OBJPROP_TIME1,Time[shift]);
            ObjectSet(name,OBJPROP_PRICE1,price1);
            ObjectSet(name,OBJPROP_TIME2,Time[shift-(separatorWidth-2)]);
            ObjectSet(name,OBJPROP_PRICE2,price2);
            ObjectSet(name,OBJPROP_COLOR,backColor);
   name = shortName+element+element+element;
   if (ObjectFind(name) == -1)
         ObjectCreate(name,OBJ_RECTANGLE,window,0,0,0,0);
            ObjectSet(name,OBJPROP_COLOR,boxColor);
            ObjectSet(name,OBJPROP_TIME1,Time[shift]);
            ObjectSet(name,OBJPROP_PRICE1,price1);
            ObjectSet(name,OBJPROP_TIME2,Time[shift-(separatorWidth-2)]);
            ObjectSet(name,OBJPROP_PRICE2,price2);
            ObjectSet(name,OBJPROP_BACK,false);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}